<script lang="ts">
import { defineComponent } from "vue";
import Flashes from "./components/FlashMessages.vue";
import Help from "./components/HelpPage.vue";
import HelpPopUp from "./components/HelpPopUp.vue";
import Statistics from "./components/StatisticsPage.vue";
import Settings from "./components/SettingsPage.vue";
import gsap from "gsap";

import * as cd from "./lib/chordDictionary";
import ChordDefDiagram from "./components/ChordDefDiagram.vue";
import type { TxType } from "./components/ChordPosition.vue";
import type { PositionType } from "./components/ChordPosition.vue";
import { useCookies } from "vue3-cookies";

// TODO provide a big mode

function mulberry32(a: number) {
  return function (): number {
    var t = (a += 0x6d2b79f5);
    t = Math.imul(t ^ (t >>> 15), t | 1);
    t ^= t + Math.imul(t ^ (t >>> 7), t | 61);
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296;
  };
}

const randomisedChordList: Array<cd.MultiChordDefinition> = [];
const chordList = cd.uniqueChordDefs();
const seededRand = mulberry32(84686581);
while (chordList.length > 0) {
  const i = Math.floor(seededRand() * 1000000) % chordList.length;
  // exclude NC and chords that don't fit on the fret board
  const chord = chordList[i];
  if (
    !chord.names.some((n) => n === "NC") &&
    !chord.chordDef.some((f) => f[0] > 5)
  ) {
    randomisedChordList.push(chordList[i]);
  }
  chordList.splice(i, 1);
}

export default defineComponent({
  components: {
    Flashes,
    Help,
    HelpPopUp,
    Statistics,
    Settings,
    ChordDefDiagram,
  },
  setup() {
    const { cookies } = useCookies();
    return { cookies };
  },
  data() {
    const epoch = Date.now();
    const days = this.dayFromEpoch(epoch);
    const chordOfTheDay =
      randomisedChordList[days % randomisedChordList.length];
    const chordDefThumbs: Array<typeof ChordDefDiagram> = [];
    const chordDefDivs: Array<typeof Element> = [];
    return {
      guessIdx: 0,
      guessesAllowed: 5,
      chordOfTheDay,
      stripFingerPositions: true,
      showHelp: false,
      showStats: false,
      showSettings: false,
      chordDefThumbs,
      chordDefDivs,
      allowGuesses: false,
      revealed: false,
      showInitialHelp: false,
      cookieData: undefined,
      epoch,
      guessedIdx: -1,
      loaded: false,
      isDark: false,
      isColourBlind: false,
      showNotes: false,
    };
  },
  mounted() {
    const dataDark = this.cookies.get("data-dark");
    if (dataDark && dataDark === "dark") {
      this.flipDarkTheme();
    }

    const dataColours = this.cookies.get("data-colours");
    if (dataColours && dataColours === "colour-blind") {
      this.flipColourBlind();
    }

    const cookieShowNotes = this.cookies.get("showNotes");
    if (cookieShowNotes && cookieShowNotes === "yes") {
      this.flipShowNotes();
    }

    this.cookieData = this.cookies.get("ukordle");
    if (this.cookieData) {
      // reload guesses from this data, zero out based on date
      const cookieDay = this.dayFromEpoch(this.cookieData.epoch);
      const currentDay = this.dayFromEpoch(this.epoch);
      if (cookieDay === currentDay) {
        this.cookieData.guesses.forEach((guess) => {
          const i = this.guessIdx++;
          setTimeout(() => {
            this.chordDefThumbs[i].revealQuickly(guess, () => {
              this.loaded = true;
            });
          }, 300);
        });

        // is the game still in progress?
        if (this.cookieData.guessed) {
          // guessed correctly
          this.guessedIdx = this.guessIdx - 1;
          setTimeout(() => {
            this.$refs.activeGuess.revealQuickly(
              this.cookieData.guesses[this.guessedIdx],
              () => {
                this.revealed = true;
              }
            );
          }, 300);

          setTimeout(() => {
            this.showStats = true;
          }, 2000);
        } else if (this.guessIdx >= this.guessesAllowed) {
          // ran out of guesses
          setTimeout(() => {
            this.$refs.activeGuess.revealQuickly(
              cd.lookUpChordDef(this.chordOfTheDay.names[0]),
              () => {
                this.revealed = true;
              }
            );
          }, 300);

          setTimeout(() => {
            this.showStats = true;
          }, 2000);
        } else {
          // still in progress, update current guess
          const guessDef = this.cookieData.activeGuess;
          setTimeout(() => {
            this.$refs.activeGuess.revealQuickly(guessDef, () => {
              this.allowGuesses = true;
            });
          }, 300);
        }
      } else {
        if (!(cookieDay === currentDay - 1 && this.cookieData.guessed)) {
          this.cookieData.currentStreak = 0;
        }
        this.cookieData.guessed = false;
        this.cookieData.guesses = [];
        this.cookieData.epoch = this.epoch;
        this.cookieData.played++;
        this.allowGuesses = true;
        this.loaded = true;
      }
    } else {
      this.cookieData = {
        guesses: [],
        activeGuess: [[0, 9, 9, 9, 9]],
        guessed: false,
        epoch: this.epoch,
        stats: [0, 0, 0, 0, 0],
        maxStreak: 0,
        currentStreak: 0,
        played: 1,
        won: 0,
      };
      setTimeout(() => {
        this.showInitialHelp = true;
        this.allowGuesses = true;
        this.loaded = true;
      }, 100);
    }
  },
  methods: {
    flipDarkTheme() {
      this.isDark = !this.isDark;
      const value = this.isDark ? "dark" : "light";
      document.documentElement.setAttribute("data-dark", value);
      this.cookies.set("data-dark", value);
    },
    flipColourBlind() {
      this.isColourBlind = !this.isColourBlind;
      const value = this.isColourBlind ? "colour-blind" : "normal";
      document.documentElement.setAttribute("data-colours", value);
      this.cookies.set("data-colours", value);
    },
    flipShowNotes() {
      this.showNotes = !this.showNotes;
      this.cookies.set("showNotes", this.showNotes ? "yes" : "no");
    },
    showFlash(message: string) {
      this.$refs.flashes.addFlash(message, 2500);
    },
    dayFromEpoch(epoch: number) {
      return Math.floor(epoch / (1000 * 60 * 60 * 24));
    },
    onActivePosUpdate(
      fretNo: number,
      stringNo: number,
      type: PositionType,
      txType: TxType
    ) {
      if (this.guessIdx < this.chordDefThumbs.length && this.guessedIdx < 0) {
        this.chordDefThumbs[this.guessIdx].updatePos(
          fretNo,
          stringNo,
          type,
          txType
        );

        // don't update cookies when revealing if the guess was right
        if (this.allowGuesses) {
          this.cookieData.activeGuess = this.$refs.activeGuess.getChordDef();

          this.cookies.set("ukordle", this.cookieData);
        }
      }
    },
    tryGuess() {
      const guessChordDef: cd.ChordDefinition =
        this.$refs.activeGuess.getChordDef();
      const guessChordNames = cd.lookUpNames(guessChordDef);
      if (
        guessChordNames.length > 0 &&
        !guessChordNames.some((a) => a === "NC")
      ) {
        const exactMatch = cd.chordDefEqual(
          cd.normaliseChordDef(this.chordOfTheDay.chordDef),
          cd.normaliseChordDef(guessChordDef)
        );

        // check each string to see what matches
        const stringToNote = ["", "G", "C", "E", "A"];
        const notesNotGuessed: Array<string> = [];
        for (let i = 1; i <= 5; ++i) {
          // check what strings match exactly
          this.chordOfTheDay.chordDef.forEach((fret) => {
            const fretNo = fret[0];
            let fretSet = false;
            // find the matching fret on the guess
            guessChordDef.forEach((checkedFret) => {
              if (
                checkedFret[0] === fretNo &&
                checkedFret[i] === 8 &&
                fret[i] === checkedFret[i]
              ) {
                checkedFret[i] = 6;
                fretSet = true;
              }
            });

            // in theory, there should only be 1 note per string, so if we haven't found it by now and it is set, record the note
            if (!fretSet && fret[i] === 8) {
              notesNotGuessed.push(cd.offsetNoteBy(stringToNote[i], fretNo));
            }
          });
        }

        // check what notes there are left to match
        guessChordDef.forEach((checkedFret) => {
          for (let i = 1; i <= 5; ++i) {
            if (checkedFret[i] === 8) {
              const checkedNote = cd.offsetNoteBy(
                stringToNote[i],
                checkedFret[0]
              );
              const j = notesNotGuessed.findIndex((n) => checkedNote === n);
              if (j >= 0) {
                // right note, wrong fret
                checkedFret[i] = 5;
                notesNotGuessed.splice(j, 1);
              } else {
                // not found
                checkedFret[i] = 7;
              }
            }
          }
        });

        this.cookieData.guesses[this.guessIdx] = guessChordDef;
        if (exactMatch) {
          this.cookieData.guessed = true;
          this.cookieData.won++;
          this.cookieData.stats[this.guessIdx]++;
          this.cookieData.currentStreak++;
          if (this.cookieData.maxStreak < this.cookieData.currentStreak) {
            this.cookieData.maxStreak = this.cookieData.currentStreak;
          }
        } else if (this.guessIdx + 1 >= this.guessesAllowed) {
          this.cookieData.currentStreak = 0;
        }
        this.cookieData.activeGuess = [[0, 9, 9, 9, 9]];

        this.cookies.set("ukordle", this.cookieData);

        this.allowGuesses = false;
        this.$refs.activeGuess.revealGuess(guessChordDef, () => {
          function mid(rect) {
            return rect.left + (rect.right - rect.left) / 2;
          }

          if (exactMatch) {
            this.guessedIdx = this.guessIdx;
            this.revealed = true;
            const flashMessage = [
              "Genius",
              "Magnificent",
              "Impressive",
              "Splendid",
              "Phew",
            ][this.guessIdx];
            this.chordDefThumbs[this.guessIdx++].doRipple(() => null);
            this.$refs.activeGuess.doRipple(() => {
              this.$refs.flashes.addFlash(flashMessage, 2600);
              setTimeout(() => {
                this.showStats = true;
              }, 4000);
            });
          } else {
            const toRect =
              this.chordDefDivs[this.guessIdx].getBoundingClientRect();
            const activeRect =
              this.$refs.activeGuessContainer.getBoundingClientRect();

            const toX = mid(toRect) - mid(activeRect);
            const toY = toRect.top - activeRect.top;

            gsap.to(this.$refs.activeGuessContainer, {
              duration: 0.7,
              opacity: 0,
              scale: 0.4,
              ease: "power2.in",
              translateX: toX,
              translateY: toY - 90,
              clearProps: "all",
              onComplete: () => {
                this.guessIdx++;
                this.$refs.activeGuess.reset();

                if (this.guessIdx < this.guessesAllowed) {
                  // try again
                  const fromRect =
                    this.chordDefDivs[this.guessIdx].getBoundingClientRect();
                  const fromX = mid(fromRect) - mid(activeRect);
                  const fromY = fromRect.top - activeRect.top;
                  gsap.from(this.$refs.activeGuessContainer, {
                    duration: 0.8,
                    opacity: 0,
                    scale: 0.4,
                    ease: "power2.out",
                    translateX: fromX,
                    translateY: fromY - 90,
                    clearProps: "all",
                    onComplete: () => {
                      this.allowGuesses = true;
                    },
                  });
                } else {
                  // run out of guesses!
                  gsap.from(this.$refs.activeGuessContainer, {
                    duration: 2,
                    opacity: 0,
                    ease: "power2.out",
                    translateY: 100,
                    clearProps: "all",
                    onComplete: () => {
                      this.$refs.activeGuess.revealGuess(
                        cd.lookUpChordDef(this.chordOfTheDay.names[0]),
                        () => {
                          this.revealed = true;
                          this.$refs.activeGuess.doRipple(() => {
                            setTimeout(() => {
                              this.showStats = true;
                            }, 2000);
                          });
                        }
                      );
                    },
                  });
                }
              },
            });
          }
        });
      } else {
        this.$refs.flashes.addFlash("Not in chord list", 1500);
        this.$refs.activeGuess.doShake();
        this.chordDefThumbs[this.guessIdx].doShake();
      }
    },
  },
});
</script>

<template>
  <header>
    <div class="menu-left">
      <i
        class="fa-regular fa-circle-question fa-lg"
        style="cursor: pointer"
        @click="showHelp = true"
      ></i>
    </div>
    <div class="title">Ukordle</div>
    <div class="menu-right">
      <i
        class="fa-solid fa-chart-bar fa-lg"
        style="cursor: pointer"
        @click="showStats = true"
      ></i>
      <i
        class="fa-solid fa-gear fa-lg"
        style="cursor: pointer"
        @click="showSettings = true"
      ></i>
    </div>
  </header>
  <main>
    <div id="guess_thumbs">
      <div
        v-for="key in [...Array(guessesAllowed).keys()]"
        :key="key"
        class="guess_thumb"
        :ref="
          (el) => {
            chordDefDivs[key] = el;
          }
        "
      >
        <ChordDefDiagram
          :ref="
            (el) => {
              chordDefThumbs[key] = el;
            }
          "
          :scale="1.1"
          :editable="false"
          :calcChordName="key < guessIdx && loaded"
          :show-notes="showNotes"
        />
      </div>
    </div>
    <div id="active_guess" ref="activeGuessContainer">
      <ChordDefDiagram
        ref="activeGuess"
        :scale="3"
        :editable="allowGuesses"
        :calc-chord-name="revealed"
        :force-correct="guessIdx >= guessesAllowed"
        :show-notes="showNotes"
        @onPosUpdate="onActivePosUpdate"
      />
    </div>
    <div id="controls" key="controls">
      <button id="try_guess" @click="tryGuess" :disabled="!allowGuesses">
        Enter
      </button>
    </div>
  </main>
  <Transition name="popup_tx">
    <div v-if="showInitialHelp" class="stats_container">
      <HelpPopUp
        @onClose="showInitialHelp = false"
        :correct-guess-text="isColourBlind ? 'Orange' : 'Green'"
        :close-guess-text="isColourBlind ? 'Blue' : 'Yellow'"
      />
    </div>
  </Transition>
  <Transition name="popup_tx">
    <div v-if="showHelp" class="help_container">
      <Help
        @onClose="showHelp = false"
        :correct-guess-text="isColourBlind ? 'Orange' : 'Green'"
        :close-guess-text="isColourBlind ? 'Blue' : 'Yellow'"
      />
    </div>
  </Transition>
  <Transition name="popup_tx">
    <div v-if="showSettings" class="help_container">
      <Settings
        @onClose="showSettings = false"
        :is-dark="isDark"
        :is-colour-blind="isColourBlind"
        :show-notes="showNotes"
        @flipDarkTheme="flipDarkTheme"
        @flipColourBlind="flipColourBlind"
        @flipShowNotes="flipShowNotes"
      />
    </div>
  </Transition>
  <Transition name="popup_tx">
    <div v-if="showStats" class="stats_container">
      <Statistics
        @onClose="showStats = false"
        :guessedIdx="guessedIdx"
        :noGuessesLeft="revealed"
        @flash="showFlash"
      />
    </div>
  </Transition>
  <Transition name="overlay_tx">
    <div v-if="showStats" class="overlay"></div>
  </Transition>

  <Flashes ref="flashes" />
</template>

<style>
* {
  -webkit-user-select: none;
  -moz-user-select: none;
  -ms-user-select: none;
  user-select: none;
  color: var(--primary);
}
*::selection {
  background: none;
}

:root {
  --correct: #538d4e;
  --close: #b59f3b;
  --incorrect: #d3d6da;
  --played: #787c7e;
  --primary: #000000;
  --secondary: #787c7e;
  --bg: #ffffff;
  --popup-bg: rgba(240, 240, 240, 0.4);
  --popup-border: 1px solid #f6f7f8;
  --unfretted-opacity: 0.08;
}

[data-dark="dark"] {
  --primary: #ffffff;
  --secondary: #d3d6da;
  --bg: #111111;
  --popup-bg: rgba(0, 0, 0, 0.5);
  --popup-border: 1px solid #000000;
  --unfretted-opacity: 0.1;
}

[data-colours="colour-blind"] {
  --correct: #f5793a;
  --close: #85c0f9;
}

#guess_thumbs {
  flex-direction: row;
  display: flex;
}

.stats_container {
  z-index: 1;
  position: fixed;
  width: 100%;
  height: 100%;
  top: 0;
  justify-content: center;
  padding-top: 4%;
  display: flex;
}

.help_container {
  z-index: 1;
  position: fixed;
  width: 100%;
  height: 100%;
  top: 0;
  background-color: var(--bg);
}

body {
  margin: 0;
  background-color: var(--bg);
}
header {
  display: flex;
  flex-direction: row;
  align-items: center;
  justify-content: space-between;
  flex-wrap: nowrap;
  padding: 0 16px;
  height: 3.1em;
  color: black;
  border-bottom: 1px solid #d3d6da;
}

.menu-left {
  display: flex;
  margin: 0;
  padding: 0;
  align-items: center;
  width: 70px;
  justify-content: flex-start;
}

header i {
  margin: 8px;
}

header .title {
  font-family: "Source Serif Pro", serif;
  font-weight: 1800;
  font-size: 37px;
  line-height: 100%;
  letter-spacing: -0.03em;
  text-align: center;
  left: 0;
  right: 0;
  pointer-events: none;
}

.menu-right {
  display: flex;
  width: 70px;
  justify-content: flex-end;
}

main {
  margin: 12px auto;
  display: flex;
  align-items: center;
  justify-content: center;
  flex-direction: column;
}

#controls {
  clear: both;
  display: flex;
  width: auto;
  align-items: center;
  justify-content: center;
}

#try_guess {
  max-width: 200px;
  min-width: 200px;
}

button {
  font-family: Arial, Helvetica, sans-serif;
  font-weight: bold;
  border: 0;
  padding: 0;
  width: 100%;
  height: 58px;
  border-radius: 4px;
  cursor: pointer;
  user-select: none;
  background-color: #d3d6da;
  color: black;
  justify-content: center;
  align-items: center;
  text-transform: uppercase;
}

button:disabled {
  cursor: not-allowed;
}

.overlay_tx-enter-active {
  transition: all 0.2s;
}
.overlay_tx-leave-active {
  transition: all 0.3s;
}

.overlay_tx-enter-from,
.overlay_tx-leave-to {
  opacity: 0;
}

.popup_tx-enter-active {
  transition: all 0.2s;
}
.popup_tx-leave-active {
  transition: all 0.3s;
}

.popup_tx-enter-from {
  margin-top: 3em;
  opacity: 0;
}
.popup_tx-leave-to {
  margin-top: 3em;
  opacity: 0;
}

.guess_tx-move {
  transition: all 1.5s ease;
}

.overlay {
  width: 100%;
  height: 100%;
  top: 0;
  left: 0;
  position: fixed;
  background-color: var(--popup-bg);
}
</style>
